﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Data.OleDb;

namespace ParsFilm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        public int IdHolder = 0;
        public string strconnection = string.Format(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0}\ParsFilm_DB.mdb", Application.StartupPath.ToString());
//*********************************************************************************
        public void SelectAll()
        {
            OleDbConnection con = new OleDbConnection(strconnection);
            OleDbCommand com = new OleDbCommand("SELECT * FROM main", con);
            OleDbDataAdapter adapter = new OleDbDataAdapter(com);
            DataSet ds = new DataSet();
            adapter.Fill(ds, "ParsFilm");
            DataTable dtContact = ds.Tables[0];
            dataGridView1.DataSource = dtContact;
            dataGridView1.Columns[0].HeaderText = "کد";
            dataGridView1.Columns[1].HeaderText = "شماره عکس";
            dataGridView1.Columns[2].HeaderText = "نام";
            dataGridView1.Columns[3].HeaderText = "نام خانوادگی";
            dataGridView1.Columns[4].HeaderText = "تاریخ";
            dataGridView1.Columns[0].Visible = false;
        }

//*********************************************************************************

        public void Update()
        {
            try
            {

                OleDbConnection con = new OleDbConnection(strconnection);
                OleDbCommand com = con.CreateCommand();

                string strUpdate = string.Format("UPDATE main SET shax=@shax,ename=@name,efamily=@family,edate=@date where ID={0}", lblid.Text);

                com.CommandText = strUpdate;

                com.Parameters.Add("@shax", OleDbType.Numeric).Value = Convert.ToInt32(txtshax.Text);
                com.Parameters.Add("@name", OleDbType.BSTR).Value = txtname.Text;
                com.Parameters.Add("@family", OleDbType.BSTR).Value = txtfamily.Text;
                com.Parameters.Add("@date", OleDbType.BSTR).Value = txtdate.Text;

                if (con.State != ConnectionState.Open)
                {
                    con.Open();
                }

                int result = com.ExecuteNonQuery();

                if (con.State != ConnectionState.Closed)
                {
                    con.Close();
                }

                if (result == 1)
                {
                    MessageBox.Show("بروز رسانی انجام شد");
                }
                else
                {
                    MessageBox.Show("خطا در بروزرسانی");
                }



            }
            catch (Exception)
            {
                MessageBox.Show("شماره عکس تکراری است");
            }
        }
//*********************************************************************************

        private void Search()
        {
            OleDbConnection con = new OleDbConnection(strconnection);

            string strSearch = string.Format("SELECT * FROM main where shax like '{0}%' or ename like '{0}%' or efamily like '{0}%' or edate like '{0}%'", txtsearch.Text);
            OleDbCommand com = new OleDbCommand(strSearch, con);
            OleDbDataAdapter adapter = new OleDbDataAdapter(com);
            DataSet ds = new DataSet();
            adapter.Fill(ds, "main_table");
            DataTable dtContact = ds.Tables[0];



            if (con.State != ConnectionState.Open)
            {
                con.Open();
            }

            dataGridView1.DataSource = dtContact;

            if (con.State != ConnectionState.Closed)
            {
                con.Close();
            }
        }


//*********************************************************************************
        private void Form1_Load(object sender, EventArgs e)
        {
            Program.SplashForm.Refresh();
            System.Threading.Thread.Sleep(3000);
            Program.SplashForm.Close();

            DateTime CurrentDateTime = DateTime.Now;
            PersianCalendar PC = new PersianCalendar();
            int PersianYear = PC.GetYear(CurrentDateTime);
            int PersianMonth = PC.GetMonth(CurrentDateTime);
            int PersianDay = PC.GetDayOfMonth(CurrentDateTime);
            txtdate.Text = PersianYear.ToString() + "/" + PersianMonth.ToString() + "/" + PersianDay.ToString();
            cmbday.SelectedIndex = PersianDay - 1;
            cmbmonth.SelectedIndex = PersianMonth - 1;
            cmbyear.SelectedIndex = (PersianYear - 1378) - 11;

            InputLanguage.CurrentInputLanguage = InputLanguage.FromCulture(System.Globalization.CultureInfo.CreateSpecificCulture("fa"));
            txtshax.Focus();
            SelectAll();
        }

        

        private void txtsearch_TextChanged(object sender, EventArgs e)
        {
            Search();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if ((txtshax.Text == string.Empty) || (txtname.Text == string.Empty) || (txtfamily.Text == string.Empty) || (txtdate.Text == string.Empty))
            {
                MessageBox.Show("لطفاً تمام اطلاعات را وارد کنید");
            }
            else if (txtdate.Text.Length < 8)
            {
                MessageBox.Show("لطفاً تاریخ را درست وارد کنید");
            }
            else
            {

                try
                {

                    OleDbConnection con = new OleDbConnection(strconnection);
                    OleDbCommand com = con.CreateCommand();
                    com.CommandType = CommandType.Text;
                    com.CommandText = "insert into main(shax,ename,efamily,edate)VALUES(@shax,@ename,@efamily,@edate)";
                    com.Parameters.Clear();
                    com.Parameters.Add("@shax", OleDbType.Numeric).Value = Convert.ToInt32(txtshax.Text);
                    com.Parameters.Add("@ename", OleDbType.BSTR).Value = txtname.Text;
                    com.Parameters.Add("@efamily", OleDbType.BSTR).Value = txtfamily.Text;
                    com.Parameters.Add("@edate", OleDbType.BSTR).Value = txtdate.Text;

                    if (con.State != ConnectionState.Open)
                    {
                        con.Open();
                    }

                    int result = com.ExecuteNonQuery();

                    if (con.State != ConnectionState.Closed)
                    {
                        con.Close();
                    }

                    if (result == 1)
                    {
                        MessageBox.Show("ثبت اطلاعات انجام شد");
                        SelectAll();
                    }
                    else
                    {
                        MessageBox.Show("اطلاعات تکراری است ");
                    }

                }
                catch (Exception)
                {
                    MessageBox.Show("اطلاعات تکراری است");
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            txtshax.Text = string.Empty;
            txtname.Text = string.Empty;
            txtfamily.Text = string.Empty;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btnDateNow_Click(object sender, EventArgs e)
        {
            DateTime CurrentDateTime = DateTime.Now;
            PersianCalendar PC = new PersianCalendar();
            int PersianYear = PC.GetYear(CurrentDateTime);
            int PersianMonth = PC.GetMonth(CurrentDateTime);
            int PersianDay = PC.GetDayOfMonth(CurrentDateTime);
            txtdate.Text = PersianYear.ToString() + "/" + PersianMonth.ToString() + "/" + PersianDay.ToString();
            cmbday.SelectedIndex = PersianDay - 1;
            cmbmonth.SelectedIndex = PersianMonth - 1;
            cmbyear.SelectedIndex = (PersianYear - 1378) - 11;
        }

        private void cmbday_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtdate.Text = cmbyear.Text + "/" + cmbmonth.Text + "/" + cmbday.Text;
        }

        private void cmbmonth_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtdate.Text = cmbyear.Text + "/" + cmbmonth.Text + "/" + cmbday.Text;
        }

        private void cmbyear_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtdate.Text = cmbyear.Text + "/" + cmbmonth.Text + "/" + cmbday.Text;
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            //try
            //{
                if (MessageBox.Show("آیا مطمئن می باشید؟", "Delete", MessageBoxButtons.OKCancel, MessageBoxIcon.None, MessageBoxDefaultButton.Button2) == DialogResult.OK)
                {
                    OleDbConnection con = new OleDbConnection(strconnection);
                    OleDbCommand com = con.CreateCommand();

                    //int SenderID = Convert.ToInt32(lblid.Text);
                    string strDel = string.Format("delete from main where ID ={0}", Convert.ToInt32(lblid.Text));
                    com.CommandText = strDel;

                    if (con.State != ConnectionState.Open)
                    {
                        con.Open();
                    }
                    int result = com.ExecuteNonQuery();
                    if (con.State != ConnectionState.Closed)
                    {
                        con.Close();
                    }
                    if (result == 1)
                    {
                        MessageBox.Show("حذف انجام شد");
                        SelectAll();
                    }
                    else
                    {
                        MessageBox.Show("حذف اطلاعات ناموفق بود");
                    }

                }
            //}
            //catch (Exception)
            //{
            //    MessageBox.Show("خطایی در برنامه رخ داده است");

            //}
        }

        private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                lblid.Text = dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString();
                txtshax.Text = dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString();
                txtname.Text = dataGridView1.Rows[e.RowIndex].Cells[2].Value.ToString();
                txtfamily.Text = dataGridView1.Rows[e.RowIndex].Cells[3].Value.ToString();
                txtdate.Text = dataGridView1.Rows[e.RowIndex].Cells[4].Value.ToString();
                btnEdit.Text = "ویرایش";
                btnSave.Enabled = true;
                btnNew.Enabled = true;
                btnDelete.Enabled = true;
                btnPrint.Enabled = true;
                btnCancel.Enabled = false;
            }
            catch (Exception)
            {
                MessageBox.Show("لطفاً یک سطر پر را انتخاب کنید");
            }
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (btnEdit.Text == "ویرایش")
            {


                if (lblid.Text == string.Empty)
                {
                    MessageBox.Show("ابتدا مشتری مورد نظر را انتخاب کنید");
                }
                else
                {

                    btnEdit.Text = "ثبت ویرایش";
                    IdHolder = Convert.ToInt32(lblid.Text);
                    btnSave.Enabled = false;
                    btnNew.Enabled = false;
                    btnDelete.Enabled = false;
                    btnPrint.Enabled = false;
                    btnCancel.Enabled = true;

                }


            }
            else
            {
                Update();
                SelectAll();

                btnEdit.Text = "ویرایش";
                btnSave.Enabled = true;
                btnNew.Enabled = true;
                btnDelete.Enabled = true;
                btnPrint.Enabled = true;
                btnCancel.Enabled = false;
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            btnEdit.Text = "ویرایش";
            btnSave.Enabled = true;
            btnNew.Enabled = true;
            btnDelete.Enabled = true;
            btnPrint.Enabled = true;
            btnCancel.Enabled = false;
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            Form2 FrmReport = new Form2();
            FrmReport.strconnection_frmprint = strconnection;

            FrmReport.strserach_frmmain = txtsearch.Text;
            FrmReport.ShowDialog();
        }

        
    }
}
